;COMPUTES TWO'S COMPLIMENT CHECKSUM FOR 8K
;OF DATA STARTING AT 100H.
;CHECKSUM IS THEN STORED AT LAST BYTE (20FFH).
;
                ORG     4000H

;LOAD IN WITH DDT TO 4000 H ADDRESS.

CKSUM:  LXI     D,1FFFH         ;BYTE COUNTER
        LXI     H,100H          ;;FIRST DATA ADDRESS
        MVI     C,0             ;;CLEAR CHECKSUM
LOOP:   MOV     A,M             ;;GET A DATA BYTE
        ADD     C               ;;ADD TO CHECKSUM
        MOV     C,A             ;;SAVE
        INX     H               ;;POINT TO NEXT BYTE
        DCX     D               ;;COUNT BYTES
        MOV     A,E             ;;GET LOW BYTE OF COUNTER
        ORA     D               ;;TEST FOR ZERO
        JNZ     LOOP            ;;LOOP IF NOT ZERO
        MOV     A,C             ;;GET CHECKSUM
        CMA                     ;;COMPLIMENT
        INR     A               ;;INCREMENT FOR 2S COMPLIMENT
        MOV     M,A             ;;PUT IT IN LAST PROM BYTE
        RST     7               ;;DDT BREAK POINT
;
        END

        